"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub:data", []).provider("DataService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        return {
          webpub: webpub //externalized webpub variable
        };
      }
    }]);

    return _class;
  }());
  angular.module("webpub:config", []).provider("ConfigService", function () {
    function _class2() {
      _classCallCheck(this, _class2);
    } // externalized config variable


    _createClass(_class2, [{
      key: "$get",
      value: function $get() {
        return config;
      }
    }]);

    return _class2;
  }());
  angular.module("webpub:additional-pages", []).provider("AdditionalPagesService", function () {
    function _class3() {
      _classCallCheck(this, _class3);
    } // externalized config variable


    _createClass(_class3, [{
      key: "$get",
      value: function $get() {
        return additionalPages;
      }
    }]);

    return _class3;
  }());

  angular.module("webpub", [
  // Start: Misc. Dependencies
  "ngRoute", "ngAnimate", "ui.router", "ui.tree", "ui.bootstrap", "ui.select", "angular.filter", "dibari.angular-ellipsis", "growlNotifications", "angularMoment", "angular-jwt", "webpub:data", "webpub:config", "webpub:additional-pages"]).config(["$stateProvider", "$locationProvider", "$urlRouterProvider", "DataServiceProvider", "AdditionalPagesServiceProvider", function ($stateProvider, $locationProvider, $urlRouterProvider, DataServiceProvider, AdditionalPagesServiceProvider) {
    $locationProvider.html5Mode(false);

    $urlRouterProvider.otherwise("/");

    var webpubData = DataServiceProvider.$get().webpub.data;

    function jwtGuard($state, jwt, $timeout, ConfigService) {
      var authEnabled = ConfigService.services && ConfigService.services.authEnabled;

      if (authEnabled && !jwt) {
        $timeout(function () {
          return $state.go("login", null);
        });
      }
    }

    $stateProvider.state("empty", {
      url: "",
      controller: function controller($state) {
        return $state.go("home");
      }
    }).state("index", {
      url: "/",
      controller: function controller($state) {
        return $state.go("home");
      }
    }).state("home", {
      url: "/home",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getIframeTemplate();
      },
      controller: "extraPageController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("home", $stateParams);
        },
        pageName: function pageName($stateParams) {
          return "home";
        },
        location: function location($stateParams) {
          return "content/start.html";
        },
        pages: function pages() {
          return [];
        }
      },
      onEnter: jwtGuard
    }).state("toc", {
      url: "/toc/:index",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getToc();
      },
      controller: "tocController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("toc", $stateParams);
        },
        conference: function conference($stateParams) {
          return webpubData.conferences[$stateParams.index];
        }
      },
      onEnter: jwtGuard
    }).state("author-index", {
      url: "/author-index",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getAuthorIndex();
      },
      controller: "authorIndexController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("author-index", $stateParams);
        },
        authors: function authors() {
          return webpubData.authors;
        }
      },
      onEnter: jwtGuard
    }).state("affiliation-index", {
      url: "/affiliation-index",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getAffiliationIndex();
      },
      controller: "affiliationIndexController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("affiliation-index", $stateParams);
        },
        affiliations: function affiliations() {
          return webpubData.affiliations;
        }
      },
      onEnter: jwtGuard
    }).state("search", {
      url: "/search",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getSearch();
      },
      controller: "searchController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("search", $stateParams);
        },
        conferences: function conferences() {
          return webpubData.conferences;
        }
      },
      onEnter: jwtGuard
    }).state("login", {
      url: "/login",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getLogin();
      },
      controller: "loginController",
      controllerAs: "$ctrl"
    }).state("extra-page", {
      params: {
        pageName: null,
        location: null
      },
      url: "/pages/:pageName",
      templateProvider: function templateProvider(TemplateService) {
        return TemplateService.getIframeTemplate();
      },
      controller: "extraPageController",
      controllerAs: "$ctrl",
      resolve: {
        jwt: function jwt(LoginService, $stateParams) {
          return LoginService.checkAndResolveJWT("extra-page", $stateParams);
        },
        pageName: function pageName($stateParams) {
          return $stateParams.pageName;
        },
        location: function location($stateParams) {
          return $stateParams.location;
        },
        pages: function pages() {
          return AdditionalPagesServiceProvider;
        }
      },
      onEnter: jwtGuard
    });
  }]).run(["$rootScope", function ($rootScope) {
    $rootScope.$on("$stateChangeError", console.log.bind(console));
  }])
  // GDPR
  .run(["$window", "ConfigService", function ($window, ConfigService) {
    if (ConfigService.enableGDPR) {
      $window.cookieconsent.initialise(json);
    }
  }]);
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("affiliationIndexController", function () {
    function affiliationIndexController(affiliations, FileService, $anchorScroll, $location, jwt) {
      _classCallCheck(this, affiliationIndexController);

      this.affiliations = affiliations;
      this.FileService = FileService;
      this.$anchorScroll = $anchorScroll;
      this.$location = $location;
      this.jwt = jwt;
    }

    _createClass(affiliationIndexController, [{
      key: "affiliationStartsWithLetter",
      value: function affiliationStartsWithLetter(affiliation, letter) {
        if (letter === "#") {
          // get alphabet letters
          var alphabet = _.tail(this.alphabet);

          // If there is no match for any alphabet letter then consider this a digit
          return !_.some(alphabet, function (nextLetter) {
            return affiliation.slice(0, 1).localeCompare(nextLetter, "en", {
              usage: "search",
              sensitivity: "base",
              ignorePunctuation: true
            }) === 0;
          });
        } else {
          // check if the string matches the current letter
          return affiliation.slice(0, 1).localeCompare(letter, "en", {
            usage: "search",
            sensitivity: "base",
            ignorePunctuation: true
          }) === 0;
        }
      }
    }, {
      key: "$onInit",
      value: function $onInit() {
        var _this = this;

        this.alphabet = "#ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
        var startIdx = 0;
        this.affiliationMap = this.alphabet.reduce(function (affiliationMap, letter) {
          // get the cutoff index
          // this is the start index of the next affiliations
          // the affiliations under the final alphabet listing with have cutoff = -1
          var cutOff = _this.affiliations.findIndex(function (a, idx) {
            return idx >= startIdx && !_this.affiliationStartsWithLetter(a.affiliation, letter);
          });

          if (cutOff >= 0) {
            // console.log(
            //   letter,
            //   startIdx,
            //   cutOff,
            //   this.affiliations.slice(startIdx, cutOff)
            // );
            affiliationMap[letter] = _this.affiliations.slice(startIdx, cutOff);
            startIdx = cutOff;
          }

          // handle the final affiliations
          else {
              // console.log(
              //   letter,
              //   startIdx,
              //   cutOff,
              //   this.affiliations.slice(startIdx)
              // );
              affiliationMap[letter] = _this.affiliations.slice(startIdx);
            }
          return affiliationMap;
        }, {});
        // console.log("affiliationMap: ", this.affiliationMap);
      }
    }, {
      key: "checkPdf",
      value: function checkPdf(location) {
        this.FileService.checkPdf(location);
      }
    }, {
      key: "scrollToAnchor",
      value: function scrollToAnchor(letter) {
        this.$location.hash(letter);
        this.$anchorScroll();
      }
    }]);

    return affiliationIndexController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("authorIndexController", function () {
    function authorIndexController(authors, FileService, $anchorScroll, $location, $state, jwt) {
      _classCallCheck(this, authorIndexController);

      this.authors = authors;
      this.FileService = FileService;
      this.$anchorScroll = $anchorScroll;
      this.$location = $location;
      this.$state = $state;
      this.jwt = jwt;
    }

    _createClass(authorIndexController, [{
      key: "authorNameStartsWithLetter",
      value: function authorNameStartsWithLetter(name, letter) {
        if (letter === "#") {
          // get alphabet letters
          var alphabet = _.tail(this.alphabet);

          // If there is no match for any alphabet letter then consider this a digit
          return !_.some(alphabet, function (nextLetter) {
            return name.slice(0, 1).localeCompare(nextLetter, "en", {
              usage: "search",
              sensitivity: "base",
              ignorePunctuation: true
            }) !== 0;
          });
        } else {
          // check if the string matches the current letter
          return name.slice(0, 1).localeCompare(letter, "en", {
            usage: "search",
            sensitivity: "base",
            ignorePunctuation: true
          }) === 0;
        }
      }
    }, {
      key: "$onInit",
      value: function $onInit() {
        var _this = this;

        this.alphabet = "#ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
        var startIdx = 0;
        this.authorMap = this.alphabet.reduce(function (authorMap, letter) {
          // get the cutoff index
          // this is the start index of the next authors
          // the authors under the final alphabet listing with have cutoff = -1
          var cutOff = _this.authors.findIndex(function (a, idx) {
            return idx >= startIdx && !_this.authorNameStartsWithLetter(a.authorName, letter);
          });

          // apply the cutoff
          if (cutOff >= 0) {
            // console.log(
            //   letter,
            //   startIdx,
            //   cutOff,
            //   this.authors.slice(startIdx, cutOff)
            // );
            authorMap[letter] = _this.authors.slice(startIdx, cutOff);
            startIdx = cutOff;
          }
          // handle the final authors
          else {
              // console.log(letter, startIdx, cutOff, this.authors.slice(startIdx));
              authorMap[letter] = _this.authors.slice(startIdx);
            }
          return authorMap;
        }, {});
        this.authorMap["A"] = (this.authorMap["#"] || []).concat(this.authorMap["A"]);
        delete this.authorMap["#"];
        this.alphabet = this.alphabet.slice(1);
        // console.log("authorMap: ", this.authorMap);
      }
    }, {
      key: "checkPdf",
      value: function checkPdf(location) {
        this.FileService.checkPdf(location);
      }
    }, {
      key: "scrollToAnchor",
      value: function scrollToAnchor(letter) {
        this.$location.hash(letter);
        this.$anchorScroll();
      }
    }]);

    return authorIndexController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("bannerController", function () {
    function bannerController(ConfigService) {
      _classCallCheck(this, bannerController);

      this.config = ConfigService;
    }

    _createClass(bannerController, [{
      key: "$onInit",
      value: function $onInit() {
        this.bannerFile = this.config.bannerFile;
      }
    }]);

    return bannerController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("extraPageController", function () {
    function extraPageController($state, pages, pageName, location, jwt) {
      _classCallCheck(this, extraPageController);

      this.$state = $state;
      this.pages = pages;
      this.pageName = pageName;
      this.location = location;
      this.jwt = jwt;
    }

    _createClass(extraPageController, [{
      key: "$onInit",
      value: function $onInit() {
        console.log("pageName: ", this.pageName);
        console.log("location: ", this.location);
        console.log("pages: ", this.pages);
      }
    }]);

    return extraPageController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("loginController", function () {
    function loginController(LoginService) {
      _classCallCheck(this, loginController);

      this.LoginService = LoginService;
    }

    _createClass(loginController, [{
      key: "$onInit",
      value: function $onInit() {}
    }, {
      key: "login",
      value: function login() {
        var _this = this;

        this.LoginService.login(this.username, this.password).catch(function (err) {
          _this.loading = false;
        });
        this.loading = true;
      }
    }]);

    return loginController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("navController", function () {
    function navController(DataService, ConfigService, AdditionalPagesService, NotificationService, LoginService, HTTPService) {
      _classCallCheck(this, navController);

      this.DataService = DataService;
      this.config = ConfigService;
      this.additionalPages = AdditionalPagesService;
      this.NotificationService = NotificationService;
      this.LoginService = LoginService;
      this.HTTPService = HTTPService;
    }

    _createClass(navController, [{
      key: "$onInit",
      value: function $onInit() {
        this.conferences = this.DataService.webpub.data.conferences;
        this.webpubDownloadEnabled = this.config.webpubDownload && this.config.webpubDownload.enabled;
        this.authEnabled = this.config.services && this.config.services.authEnabled;
      }
    }, {
      key: "onWebpubDownloadClicked",
      value: function onWebpubDownloadClicked($event) {
        $event.preventDefault();

        var downloadParams = "";
        var jwt = null;
        if (this.webpubDownloadEnabled) {
          if (this.authEnabled) {
            jwt = this.LoginService.checkAndResolveJWT();
            downloadParams = jwt ? "?token=" + jwt.token : "";
          }
        }
        var webpubDownloadLocation = "" + this.config.webpubDownload.location + downloadParams;

        // check if auth needed
        if (this.authEnabled && !jwt) {
          this.NotificationService.send("danger", "You must be logged in to do that.");
          return;
        }

        // track download if enabled
        // TODO move to service
        if (this.config.services && this.config.services.trackingEnabled) {
          var trackingURL = this.config.services && this.config.services.trackingURL;
          if (!trackingURL) {
            console.error("trackingURL not defined in config.services");
            return;
          }
          var strategy = this.config.services && this.config.services.strategy;
          if (!strategy) {
            console.error("strategy not defined in config.services");
            return;
          }

          this.HTTPService.post(trackingURL, {
            action: "webpub download",
            strategy: strategy
          }, jwt).catch(function (error) {
            console.error("Webpub download tracking error: ", error);
          });
        }

        window.open(webpubDownloadLocation, "_blank");
      }
    }]);

    return navController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  var RESERVED_OBJECT_PROPERTIES = new Set(Object.getOwnPropertyNames(Object.prototype));

  angular.module("webpub").controller("searchController", function () {
    function searchController(conferences, FileService, jwt) {
      _classCallCheck(this, searchController);

      this.conferences = conferences;
      this.FileService = FileService;
      this.jwt = jwt;
    }

    _createClass(searchController, [{
      key: "$onInit",
      value: function $onInit() {
        this.searchMap = this.conferences.reduce(function (searchMap, conference) {
          conference.sections.forEach(function (section) {
            section.lineItems.forEach(function (entry) {
              entry.searchText.toLowerCase().split(" ").forEach(function (token) {
                var isTokenReserved = RESERVED_OBJECT_PROPERTIES.has(token);
                token = isTokenReserved ? "___" + token : token;
                var entryList = searchMap[token] || [];
                entryList.push(entry);
                searchMap[token] = entryList;
              });
            });
          });
          return searchMap;
        }, {});

        this.idMap = this.conferences.reduce(function (idMap, conference) {
          conference.sections.forEach(function (section) {
            section.lineItems.forEach(function (entry) {
              idMap[entry.id] = entry;
            });
          });
          return idMap;
        }, {});
      }
    }, {
      key: "checkPdf",
      value: function checkPdf(item) {
        this.FileService.checkPdf(item.articleLocation);
      }
    }, {
      key: "getAbstract",
      value: function getAbstract(entry) {
        return entry.abstract || "No abstract provided";
      }
    }, {
      key: "searchInput",
      value: function searchInput() {
        var _this = this;

        if (this.searchTerm.length < 3) return;

        var hitMap = this.searchTerm.split(" ").filter(function (token) {
          return token;
        }).reduce(function (hitMap, token) {
          var isTokenReserved = RESERVED_OBJECT_PROPERTIES.has(token.toLowerCase());
          token = (isTokenReserved ? "___" + token : token).toLowerCase();
          if (!_this.searchMap[token]) return hitMap;

          _this.searchMap[token].forEach(function (entry) {
            var hits = hitMap[entry.id] || 0;
            hits += 1;
            hitMap[entry.id] = hits;
          });

          return hitMap;
        }, {});

        this.searchResults = Object.keys(hitMap).map(function (id) {
          return {
            entry: _this.idMap[id],
            hits: hitMap[id]
          };
        }).sort(function (a, b) {
          return b.hits - a.hits;
        }).map(function (result) {
          return result.entry;
        });

        console.log("results: ", this.searchResults);
      }
    }]);

    return searchController;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").controller("tocController", function () {
    function tocController(conference, FileService, $scope, $location, $anchorScroll, VideoPlayerService, ConfigService, jwt) {
      _classCallCheck(this, tocController);

      this.conference = conference;
      this.FileService = FileService;
      this.$scope = $scope;
      this.$location = $location;
      this.$anchorScroll = $anchorScroll;
      this.VideoPlayerService = VideoPlayerService;
      this.ConfigService = ConfigService;
      this.jwt = jwt;
    }

    _createClass(tocController, [{
      key: "$onInit",
      value: function $onInit() {
        var _this = this;

        this.playerSetting = this.ConfigService.videoPlayer || "default";
        this.conference.backMatter = this.conference.backMatter.filter(function (entry) {
          return entry.type !== "BM_ROSTER";
        });
        this.anchors = [{ name: "Jump to Section...", value: "jump" }, { name: "\u2022 Front Matter", value: "FrontMatter" }].concat(this.conference.sections.map(function (s) {
          var indent = s.type === "SD_TRACK" ? "" : s.type === "SD_SESSION" ? "\xA0\xA0\xA0" : "\xA0\xA0\xA0\xA0\xA0\xA0";
          console.log(s);
          return {
            name: indent + "\u2022\xA0" + s.title,
            value: _this.getTitleId(s.title)
          };
        })).concat([{ name: "\u2022 Back Matter", value: "BackMatter" }]);
        this.selectedAnchor = "jump";

        this.$scope.$watch(function () {
          return _this.selectedAnchor;
        }, function () {
          if (_this.selectedAnchor !== "jump") {
            _this.$location.hash(_this.selectedAnchor);
            _this.$anchorScroll();
          }
        });
      }
    }, {
      key: "checkPdf",
      value: function checkPdf(item) {
        this.FileService.checkPdf(item.articleLocation);
      }
    }, {
      key: "handleExtraClick",
      value: function handleExtraClick(entry, extra, $event) {
        // if the extra is a video -> defer to the video player service
        if (this.useVideoPlayer(extra)) {
          $event.preventDefault();
          this.VideoPlayerService.openVideo(entry, extra, this.jwt).catch(function (err) {
            return console.error(err);
          });
        }
        // Otherwise check that the file exists -> display a notification if not found
        else {
            this.FileService.checkExtra(extra.location);
          }
      }
    }, {
      key: "useVideoPlayer",
      value: function useVideoPlayer(extra) {
        return this.VideoPlayerService.isMP4(extra.location) && this.playerSetting !== "link";
      }
    }, {
      key: "getTitleId",
      value: function getTitleId(title) {
        return title.replace(/ /g, "");
      }
    }, {
      key: "getSectionClass",
      value: function getSectionClass(section) {
        if (section.class === "SD") if (section.type === "SD_SESSION") {
          return "h4";
        } else if (section.type === "SD_SUBSESSION") {
          return "h5";
        } else if (section.type === "SD_TRACK") {
          return "h3";
        }
      }
    }, {
      key: "chairName",
      value: function chairName(section) {
        return section.chair && section.chair.title && section.chair.name ? section.chair.title + ": " + section.chair.name : "";
      }
    }]);

    return tocController;
  }());
})();
"use strict";

(function () {
  "use strict";

  angular.module("webpub").filter("entryPageNumberFilter", function () {
    return function (entry) {
      if (!entry) return entry;
      if (!entry.pageNumber) return entry.pageNumber;
      if (entry.isPageNumberRoman) {
        return toRoman(entry.pageNumber);
      } else {
        return entry.pageNumber;
      }
    };
  });

  function toRoman(num) {
    var result = "";
    var decimal = [1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1];
    var roman = ["m", "cm", "d", "cd", "c", "xc", "l", "xl", "x", "ix", "v", "iv", "i"];
    for (var i = 0; i <= decimal.length; i++) {
      while (num % decimal[i] < num) {
        result += roman[i];
        num -= decimal[i];
      }
    }
    return result;
  }
})();
"use strict";

(function () {
  "use strict";

  angular.module("webpub").filter("extraLinkFilter", ["ConfigService", "VideoPlayerService", function (ConfigService, VideoPlayerService) {
    var playerSetting = ConfigService.videoPlayer || "default";
    return function (extra) {
      // if its an MP4 video and we're not using "link" mode
      // return an empty link
      if (VideoPlayerService.isMP4(extra.location) && playerSetting !== "link") {
        return "#";
      }
      // otherwise return a link to the extra file
      else {
          return extra.location;
        }
    };
  }]);
})();
"use strict";

(function () {
  "use strict";

  angular.module("webpub").filter("fileUrlFilter", [function () {
    return function (url, jwt) {
      var tokenParam = jwt ? "?token=" + jwt.token : "";
      return "" + url + tokenParam;
    };
  }]);
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("FileService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get($window, NotificationService) {
        function checkFile(type, location) {
          if (!location) {
            NotificationService.send("danger", type + " file not found for article");
          }
        }

        function checkPdf(location) {
          return checkFile("PDF", location);
        }

        function checkExtra(location) {
          return checkFile("Extra", location);
        }

        return {
          checkPdf: checkPdf,
          checkExtra: checkExtra
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("HTTPService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get($http) {
        var get = function get(url) {
          return $http({
            url: url,
            method: "GET"
            // headers: {
            //   'Content-Type': 'application/json; charset=utf-8'
            // }
          });
        };

        var post = function post(url, body, jwt) {
          var postOptions = {
            url: url,
            method: "POST",
            data: body,
            headers: {
              "Content-Type": "application/json; charset=utf-8"
            }
          };
          if (jwt) {
            postOptions.headers.Authorization = "Bearer " + jwt.token;
          }
          return $http(postOptions);
        };

        return {
          get: get,
          post: post
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("LoginService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "verifyConfigHasFields",
      value: function verifyConfigHasFields(config, fields) {
        if (!config.services) {
          throw new Error("Services not defined in config");
        }
        fields.forEach(function (fieldName) {
          if (!config.services[fieldName]) {
            throw new Error(fieldName + " is not defined in config.services");
          }
        });
        return config.services;
      }
    }, {
      key: "$get",
      value: function $get(moment, $state, ConfigService, HTTPService, NotificationService, jwtHelper) {
        var _this = this;

        // this will only hold one element, but we want to use the push and pop methods
        var returnState = [];

        var login = function login(username, password) {
          var _verifyConfigHasField = _this.verifyConfigHasFields(ConfigService, ["confId", "strategy", "loginURL"]),
              confId = _verifyConfigHasField.confId,
              strategy = _verifyConfigHasField.strategy,
              loginURL = _verifyConfigHasField.loginURL;

          return HTTPService.post(loginURL, {
            username: username,
            password: password,
            confId: confId,
            strategy: strategy
          }).then(function (response) {
            storeJWTtoLocalStorage(response.data.jwt);

            var _ref = returnState.pop() || {
              state: "home",
              stateParams: {}
            },
                state = _ref.state,
                stateParams = _ref.stateParams;

            $state.go(state, stateParams);
          }).catch(function (error) {
            console.error("Login Error: ", error);
            NotificationService.send("danger", "Invalid username or password");
            throw error;
          });
        };

        var checkAndResolveJWT = function checkAndResolveJWT(currentState, stateParams) {
          if (!ConfigService.services || !ConfigService.services.authEnabled) {
            return null;
          }

          var _verifyConfigHasField2 = _this.verifyConfigHasFields(ConfigService, ["confId"]),
              confId = _verifyConfigHasField2.confId;

          var jwtString = localStorage.getItem(confId + "_JWT");

          // check if a JWT exists
          if (!jwtString) {
            console.error("JWT not found");
            if (currentState) {
              returnState.push({ state: currentState, stateParams: stateParams });
            }
            return null;
          }

          // check the expiration date
          if (jwtHelper.isTokenExpired(jwtString)) {
            console.error("JWT is expired");
            if (currentState) {
              returnState.push({ state: currentState, stateParams: stateParams });
            }
            return null;
          }

          // return the jwtString and decodedJWT if the above checks pass
          return {
            token: jwtString,
            data: jwtHelper.decodeToken(jwtString)
          };
        };

        var storeJWTtoLocalStorage = function storeJWTtoLocalStorage(jwtToken) {
          var _verifyConfigHasField3 = _this.verifyConfigHasFields(ConfigService, ["confId"]),
              confId = _verifyConfigHasField3.confId;

          localStorage.setItem(confId + "_JWT", jwtToken);
        };

        return {
          login: login,
          checkAndResolveJWT: checkAndResolveJWT
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("NotificationService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var notifications = [];
        var send = function send(type, message) {
          notifications.push({
            type: type,
            message: message
          });
        };
        return {
          notifications: notifications,
          send: send
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("TemplateService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get(helloTemplate, tocTemplate, authorIndexTemplate, iframeTemplate, searchTemplate, affiliationIndexTemplate, videoPlayerModalTemplate, loginTemplate) {
        return {
          getHello: function getHello() {
            return helloTemplate.content();
          },
          getToc: function getToc() {
            return tocTemplate.content();
          },
          getAuthorIndex: function getAuthorIndex() {
            return authorIndexTemplate.content();
          },
          getAffiliationIndex: function getAffiliationIndex() {
            return affiliationIndexTemplate.content();
          },
          getIframeTemplate: function getIframeTemplate() {
            return iframeTemplate.content();
          },
          getSearch: function getSearch() {
            return searchTemplate.content();
          },
          getVideoPlayer: function getVideoPlayer() {
            return videoPlayerModalTemplate.content();
          },
          getLogin: function getLogin() {
            return loginTemplate.content();
          }
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("VideoPlayerService", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get($uibModal, ConfigService) {
        function isMP4(filename) {
          return filename.split(".").slice(-1)[0].toLowerCase() === "mp4";
        }

        function openVideo(_entry, _extra, _jwt) {
          var modal = $uibModal.open({
            component: "webpubVideoPlayerModal",
            size: "lg",
            resolve: {
              entry: function entry() {
                return _entry;
              },
              extra: function extra() {
                return _extra;
              },
              jwt: function jwt() {
                return _jwt;
              },
              playerSetting: getPlayerSetting
            }
          });

          return modal.result;
        }

        function getPlayerSetting() {
          var configSetting = ConfigService.videoPlayer;
          console.log("player configuration setting: ", configSetting);
          if (configSetting && configSetting !== "default") {
            return configSetting;
          } else {
            var proto = window.location.protocol;
            if (proto.toLowerCase().startsWith("file")) {
              console.log("Detected file protocol");
              return "native";
            } else {
              console.log("Detected hosted protocol");
              return "native";
            }
          }
        }

        return {
          openVideo: openVideo,
          isMP4: isMP4
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
    "use strict";

    angular.module("webpub").provider("affiliationIndexTemplate", function () {
        function _class() {
            _classCallCheck(this, _class);
        }

        _createClass(_class, [{
            key: "$get",
            value: function $get() {
                var content = function content() {
                    return "<div class=\"row\">\n    <div class=\"col-md-12\">\n        <div class=\"btn-toolbar pt\" role=\"toolbar\">\n            <div class=\"btn-group\">\n                <button class=\"btn btn-default\" data-ng-repeat=\"letter in $ctrl.alphabet\" data-ng-click=\"$ctrl.scrollToAnchor(letter)\">{{letter}}</button>\n            </div>\n        </div>\n    </div>    \n</div>\n<div class=\"row\">\n    <div class=\"col-md-12\">\n        <h1>Affiliation Index</h1>\n        <div data-ng-repeat=\"letter in $ctrl.alphabet\">\n            <h3 id=\"{{letter}}\">{{letter}}</h3>\n            <div data-ng-repeat=\"aff in $ctrl.affiliationMap[letter]\">\n                <p style=\"margin-bottom: 0\">{{aff.affiliation}}</p>\n                <div data-ng-repeat=\"article in aff.articleRefs\"\n                     style=\"margin-bottom: 5px\">\n                    <a data-ng-href=\"{{article.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" data-ng-click=\"$ctrl.checkPdf(article.articleLocation)\">{{article.articleName}}</a>\n                </div>\n            </div>\n        </div>        \n    </div>\n</div>\n\n";
                };

                return {
                    content: content
                };
            }
        }]);

        return _class;
    }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
    "use strict";

    angular.module("webpub").provider("authorIndexTemplate", function () {
        function _class() {
            _classCallCheck(this, _class);
        }

        _createClass(_class, [{
            key: "$get",
            value: function $get() {
                var content = function content() {
                    return "<div class=\"row\">\n    <div class=\"col-md-12\">\n        <div class=\"btn-toolbar pt\" role=\"toolbar\">\n            <div class=\"btn-group\">\n                <button class=\"btn btn-default\" data-ng-repeat=\"letter in $ctrl.alphabet\" data-ng-click=\"$ctrl.scrollToAnchor(letter)\">{{letter}}</button>\n            </div>\n        </div>\n    </div>    \n</div>\n<div class=\"row\">\n    <div class=\"col-md-12\">\n        <h1>Author Index</h1>\n        <div data-ng-repeat=\"letter in $ctrl.alphabet\">\n            <h3 id=\"{{letter}}\">{{letter}}</h3>\n            <div data-ng-repeat=\"author in $ctrl.authorMap[letter]\">\n                <p style=\"margin-bottom: 0\">{{author.authorName}}</p>\n                <div data-ng-repeat=\"article in author.articleRefs\"\n                     style=\"margin-bottom: 5px\">\n                    <a data-ng-href=\"{{article.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" data-ng-click=\"$ctrl.checkPdf(article.articleLocation)\">{{article.articleName}}</a>\n                </div>\n            </div>\n        </div>        \n    </div>\n</div>\n\n";
                };

                return {
                    content: content
                };
            }
        }]);

        return _class;
    }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("helloTemplate", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var content = function content() {
          return "\n                        <div>{{$ctrl.hello()}}</div>\n                    ";
        };

        return {
          content: content
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("iframeTemplate", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var content = function content() {
          return "<div class=\"row\">\n    <div class=\"col-md-12\">\n        <div class=\"embed-responsive embed-responsive-16by9\">\n            <iframe class=\"embed-responsive-item\" data-ng-src=\"{{$ctrl.location}}\"></iframe>\n        </div>        \n    </div>\n</div>";
        };

        return {
          content: content
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("loginTemplate", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var content = function content() {
          return "\n          <div class=\"login-wrapper\">\n            <div class=\"login-formContent\">\n              <!-- Title -->\n              <div>\n                <h1 class=\"login-title\">Sign In</h1>\n              </div>\n        \n              <!-- Login Form -->\n              <form data-ng-hide=\"$ctrl.loading\" ng-submit=\"$ctrl.login()\">\n                <input type=\"text\" id=\"login\" name=\"login\" placeholder=\"Username\" class=\"login-input\" data-ng-model=\"$ctrl.username\">\n                <input type=\"password\" id=\"password\" name=\"login\" placeholder=\"Password\" class=\"login-input\" data-ng-model=\"$ctrl.password\">\n                <input data-ng-hide=$ctrl.loading type=\"submit\" class=\"login-button\" value=\"Sign In\">\n              </form>\n              \n              <div data-ng-show=\"$ctrl.loading\" class=\"pv-lg\">\n                <i class=\"fa fa-circle-o-notch fa-spin fa-3x fa-fw loading\"></i>\n                <span class=\"sr-only\">Loading...</span>\n              </div>\n              \n        \n              <!-- Remind Passowrd -->\n              <!-- <div class=\"login-formFooter\">\n                <a class=\"underlineHover\" href=\"#\">Go to the Site</a>\n              </div> -->\n        \n            </div>\n          </div>";
        };

        return {
          content: content
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("searchTemplate", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var content = function content() {
          return "<div class=\"row mt-lg\">\n    <div class=\"col-md-12\">\n        <div class=\"input-group custom-search-form\">\n            <input type=\"text\" class=\"form-control\" data-ng-change=\"$ctrl.searchInput()\" data-ng-model=\"$ctrl.searchTerm\" placeholder=\"Search...\">\n            <span class=\"input-group-btn\">\n                <button class=\"btn btn-default\" type=\"button\">\n                    <i class=\"fa fa-search\"></i>\n                </button>\n            </span>\n        </div>\n        <hr>\n        <h3 data-ng-if=\"$ctrl.searchResults && $ctrl.searchResults.length\">Results:</h3>\n        <div data-ng-repeat=\"result in $ctrl.searchResults\">\n            <a class=\"text-bold\" data-ng-href=\"{{result.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" ng-click=\"$ctrl.checkPdf(result)\">{{result.text}}</a>\n            <p class=\"pl-lg\"><em>{{result.authorNames}}</em></p>\n            <p class=\"pl-lg search-result\" data-ng-bind=\"$ctrl.getAbstract(result)\" data-ellipsis></p>\n        </div>\n    </div>\n</div>";
        };

        return {
          content: content
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
    "use strict";

    angular.module("webpub").provider("tocTemplate", function () {
        function _class() {
            _classCallCheck(this, _class);
        }

        _createClass(_class, [{
            key: "$get",
            value: function $get() {
                var content = function content() {
                    return "<div class=\"row\">\n    <div class=\"col-md-12\">\n        <div class=\"row\">\n            <div class=\"col-xs-8\">\n                <h1 class=\"text-bold\">{{$ctrl.conference.acronym}} {{$ctrl.conference.year}}</h1>\n            </div>\n            <div class=\"col-xs-4\">\n                <select class=\"form-control mt-xl\"\n                    data-ng-model=\"$ctrl.selectedAnchor\"\n                    data-ng-options=\"anchor.value as anchor.name for anchor in $ctrl.anchors\">                    \n                </select>\n            </div>\n        </div>        \n        <h2>{{$ctrl.conference.title}}</h2>\n        <h3>Table of Contents</h3>\n        <h3 class=\"text-bold\" id=\"FrontMatter\">Front Matter<span class=\"pull-right text-normal\">Page Number</span></h3>\n        <div data-ng-repeat=\"fm in $ctrl.conference.frontMatter\">\n            <a class=\"text-bold\" data-ng-href=\"{{fm.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" ng-click=\"$ctrl.checkPdf(fm)\">{{fm.text}}<span class=\"pull-right\">{{fm | entryPageNumberFilter}}</span></a>\n            <div data-ng-repeat=\"extra in fm.extraLocations\" class=\"pb\">\n                <a class=\"pl-lg\" data-ng-href=\"{{extra | extraLinkFilter | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" data-ng-click=\"$ctrl.handleExtraClick(fm, extra, $event)\">\n                  <span data-ng-if=\"$ctrl.useVideoPlayer(extra)\" class=\"fa fa-video-camera mr-sm\"></span>\n                  {{extra.name}}\n                </a>\n            </div>\n        </div>\n        <div data-ng-repeat=\"section in $ctrl.conference.sections\">\n            <hr>\n            <h3 class=\"text-bold\" data-ng-class=\"$ctrl.getSectionClass(section)\" id=\"{{$ctrl.getTitleId(section.title)}}\">{{section.title}}</h3>\n            <p class=\"text-bold\">{{$ctrl.chairName(section)}}</p>\n            <div data-ng-repeat=\"item in section.lineItems\">\n                <a class=\"text-bold\" data-ng-href=\"{{item.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" ng-click=\"$ctrl.checkPdf(item)\">{{item.text}}<span class=\"pull-right\">{{item | entryPageNumberFilter}}</span></a>\n                <p class=\"pl-lg\"><em>{{item.authorNames}}</em></p>\n                <div data-ng-repeat=\"extra in item.extraLocations\" class=\"pb\">\n                    <a class=\"pl-lg\" data-ng-href=\"{{extra | extraLinkFilter | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" data-ng-click=\"$ctrl.handleExtraClick(item, extra, $event)\">\n                      <span data-ng-if=\"$ctrl.useVideoPlayer(extra)\" class=\"fa fa-video-camera mr-sm\"></span>\n                      {{extra.name}}\n                    </a>                    \n                </div>\n                \n            </div>\n        </div>\n        <hr>\n        <h3 class=\"text-bold\" id=\"BackMatter\"></h3>\n        <div data-ng-repeat=\"bm in $ctrl.conference.backMatter\">\n            <a class=\"text-bold\" data-ng-href=\"{{bm.articleLocation | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" ng-click=\"$ctrl.checkPdf(bm)\">{{bm.text}}<span class=\"pull-right\">{{bm | entryPageNumberFilter}}</span></a>\n            <div data-ng-repeat=\"extra in bm.extraLocations\" class=\"pb\">\n                <a class=\"pl-lg\" data-ng-href=\"{{extra | extraLinkFilter | fileUrlFilter : $ctrl.jwt}}\" target=\"_blank\" data-ng-click=\"$ctrl.handleExtraClick(bm, extra, $event)\">\n                    <span data-ng-if=\"$ctrl.useVideoPlayer(extra)\" class=\"fa fa-video-camera mr-sm\"></span>\n                    {{extra.name}}\n                </a>\n            </div>\n        </div>\n    </div>\n</div>\n";
                };

                return {
                    content: content
                };
            }
        }]);

        return _class;
    }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").provider("videoPlayerModalTemplate", function () {
    function _class() {
      _classCallCheck(this, _class);
    }

    _createClass(_class, [{
      key: "$get",
      value: function $get() {
        var content = function content() {
          return "\n<div class=\"modal-header\">\n    <button type=\"button\" class=\"close\" data-ng-click=\"$ctrl.onClose()\"><span>&times;</span></button>\n    <h4 class=\"modal-title\">{{$ctrl.entry.text}}&nbsp;{{$ctrl.playerSetting}}</h4>\n</div>\n<div class=\"modal-body\" id=\"modal-body\">\n    <div id=\"videoWrapper\">\n        <video id=\"videoPlayer\" controls=\"controls\">\n            <source id=videoSource src=\"\" type=\"video/mp4\" />\n        </video> \n    </div>          \n</div>\n";
        };

        return {
          content: content
        };
      }
    }]);

    return _class;
  }());
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").component("webpubNotifications", {
    bindings: {},
    controller: function () {
      function controller(NotificationService) {
        _classCallCheck(this, controller);

        this.NotificationService = NotificationService;
      }

      _createClass(controller, [{
        key: "$onInit",
        value: function $onInit() {
          this.notifications = this.NotificationService.notifications;
        }
      }]);

      return controller;
    }(),
    template: "<!-- Hide the notifications module until the application loads. -->\n                <div data-ng-cloak>\n                    <div class=\"notifications\"\n                         data-growl-notifications\n                         data-ng-if=\"$ctrl.notifications\">\n                \n                        <!-- (notifications) Notifications list -->\n                        <div data-ng-repeat=\"notification in $ctrl.notifications\">\n                            <div class=\"notification fading\"\n                                 data-growl-notification\n                                 data-ng-class=\"notification.type\">{{ notification.message }}</div>\n                        </div>                \n                    </div>\n                </div>\n                "
  });
})();
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  "use strict";

  angular.module("webpub").component("webpubVideoPlayerModal", {
    bindings: {
      close: "&",
      dismiss: "&",
      size: "@",
      resolve: "<"
    },
    template: function template(TemplateService) {
      return TemplateService.getVideoPlayer();
    },
    controller: function () {
      function controller($scope) {
        _classCallCheck(this, controller);

        this.$scope = $scope;
      }

      _createClass(controller, [{
        key: "$onInit",
        value: function $onInit() {
          var _this = this;

          // handle resolves
          this.entry = this.resolve.entry;
          this.extra = this.resolve.extra;
          this.playerSetting = this.resolve.playerSetting;
          this.jwt = this.resolve.jwt;

          // declare helper variables
          var playerSetting = this.playerSetting;
          this.isNative = false;
          this.isVideoJs = false;
          this.isMediaElement = false;

          // set player type variables
          if (playerSetting === "videojs") {
            this.isVideoJs = true;
          } else if (playerSetting === "mediaelement") {
            this.isMediaElement = true;
          } else {
            this.isNative = true;
          }

          // clean up non-native player objects when modal closes
          this.$scope.$on("modal.closing", function (event, reason, closed) {
            console.log("modal closing: ", event, reason, closed);
            if (_this.isVideoJs) {
              // call dispose if player type is videoJs
              _this.videoPlayer.dispose();
            } else if (_this.isMediaElement) {
              // pause then remove player if type is MediaElement
              if (!_this.videoPlayer.paused) {
                _this.videoPlayer.pause();
              }
              _this.videoPlayer.remove();
            }
          });
        }

        // $postLink is called after components and children are added to DOM

      }, {
        key: "$postLink",
        value: function $postLink() {
          this.setSource();
          // initialize MediaElement player
          if (this.isMediaElement) {
            this.videoPlayer = new MediaElementPlayer("videoPlayer", {
              defaultVideoHeight: 480,
              success: function success(mediaElement, node, instance) {
                console.log("Media element player is loaded: ", mediaElement, node, instance);
                node.classList.add("height-width-100");
              },
              error: function error(_error, mediaElement, node) {
                console.error("Error loading media element player: ", _error, media, node);
              }
            });
          }
          // initialize videoJs player
          else if (this.isVideoJs) {
              this.setSource();
              this.setVideoClasses();
              this.videoPlayer = videojs("videoPlayer");
            }
            // initialize Native Video Source
            else {
                this.setVideoClasses();
                this.setSource();
              }
        }
      }, {
        key: "onClose",
        value: function onClose() {
          this.close();
        }

        /** The videoJs API seemed to not set the video source properly when using the usual angular handlebars
         * Good ol' JQuery should do the trick
         */

      }, {
        key: "setSource",
        value: function setSource() {
          var videoSource = angular.element("#videoSource");
          var jwtParam = this.jwt ? "?token=" + this.jwt.token : "";
          videoSource.attr("src", "" + this.extra.location + jwtParam);
        }

        /**
         * Set classes specific to the video player being used
         * This seems to work better in JQuery for some players
         */

      }, {
        key: "setVideoClasses",
        value: function setVideoClasses() {
          var videoPlayer = angular.element("#videoPlayer");
          var videoWrapper = angular.element("#videoWrapper");
          if (this.isVideoJs) {
            videoPlayer.addClass("video-js vjs-16-9");
          } else if (this.isMediaElement) {
            videoPlayer.addClass("height-width-100");
          } else {
            videoPlayer.attr("height", 480);
            videoPlayer.css({ width: "100%", outline: "none" });
            videoWrapper.css("background-color", "#000");
          }
        }
      }]);

      return controller;
    }()
  });
})();